routes/web.php
<?php

use App\Http\Controllers\Admin\CommentController;
use App\Http\Controllers\Admin\PhotoController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\CommentsController;
use App\Http\Controllers\LanguageSwitcherController;
use App\Http\Controllers\PhotosController;
use App\Http\Controllers\UsersController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/



Route::middleware('language')->group(function (){


    Route::prefix('admin')->middleware('auth')->name('admin.')->group(function () {
        Route::resources([
            'users' => UserController::class,
            'photos' => PhotoController::class,
            'comments' => CommentController::class,
        ]);
    });

    Route::get('/', [PhotosController::class, 'index'])->name('main');
    Auth::routes();
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::resource('photos', PhotosController::class)->except(['edit', 'update']);
    Route::resource('users', UsersController::class)->except(['create', 'store', 'destroy']);
    Route::resource('comments', CommentsController::class)->only('store');
});


Route::get('language/{locale}', [LanguageSwitcherController::class, 'switcher'])->name('language.switcher')->where('locale', 'en|ru');

app/Models/Photo.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @method static paginate(int $int)
 */
class Photo extends Model
{
    use HasFactory;

    protected $fillable = ['title', 'picture', 'user_id'];

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class)->latest();
    }
}

app/Http/Controllers/Admin/PhotoController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\PhotoRequest;
use App\Models\Photo;
use App\Models\User;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PhotoController extends Controller
{

    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $photos = Photo::all();
        return view('admin.photos.index', compact('photos'));
    }


    /**
     * @return Application|Factory|View
     */
    public function create()
    {
        $users = User::all();
        return view('admin.photos.create', compact('users'));
    }


    /**
     * @param PhotoRequest $request
     * @return RedirectResponse
     */
    public function store(PhotoRequest $request): RedirectResponse
    {
        $photo = new Photo($request->all());
        if ($request->hasFile('picture')){
            $photo->picture = $request->file('picture')->store('pictures', 'public');
        }
        $photo->save();
        return redirect()->route('admin.photos.index')->with('success', "photo success created");
    }


    /**
     * @param Photo $photo
     * @return Application|Factory|View
     */
    public function show(Photo $photo)
    {

        return view('admin.photos.show', compact('photo'));
    }



    /**
     * @param Photo $photo
     * @return Application|Factory|View
     */
    public function edit(Photo $photo)
    {
        $users = User::all();
        return view('admin.photos.edit', compact('photo', 'users'));
    }


    /**
     * @param PhotoRequest $request
     * @param Photo $photo
     * @return RedirectResponse
     */
    public function update(PhotoRequest $request, Photo $photo): RedirectResponse
    {
        $data = $request->all();
        if ($request->hasFile('picture')) {
            $file = $request->file('picture');
            $path = $file->store('pictures', 'public');
            $data['picture'] = $path;
        }
        $photo->update($data);
        return redirect()->route('admin.photos.index')->with('success', "photo success updated");
    }


    /**
     * @param Photo $photo
     * @return RedirectResponse
     */
    public function destroy(Photo $photo): RedirectResponse
    {
        $photo->delete();
        return redirect()->route('admin.photos.index')->with('success', "photo success deleted");
    }
}

app/Http/Controllers/PhotosController.php
<?php

namespace App\Http\Controllers;

use App\Models\Photo;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class PhotosController extends Controller
{

    public function __construct()
    {
        return $this->middleware('auth')->except(['index', 'show']);
    }

    /**
     * @return Application|Factory|View
     */
    public function index()
    {
        $photos = Photo::latest()->paginate(6);
        return view('photos.index', compact('photos'));
    }


    /**
     * @return Application|Factory|View
     */
    public function create()
    {
        return view('photos.create');
    }


    /**
     * @param Request $request
     * @return RedirectResponse
     */
    public function store(Request $request): RedirectResponse
    {
        $request->validate([
            'title' => ['bail', 'required', 'min:2'],
            'picture' => ['bail', 'required', 'mimes:jpg,png'],
        ]);
        $photo = new Photo();
        $photo->title = $request->input('title');
        if ($request->hasFile('picture')){
            $photo->picture = $request->file('picture')->store('pictures', 'public');
        }
        $photo->user_id = Auth::user()->getAuthIdentifier();
        $photo->save();

        return redirect()->route('photos.index')->with('success', 'photo successfully created');
    }


    /**
     * @param Photo $photo
     * @return Application|Factory|View
     */
    public function show(Photo $photo)
    {
        $total = 0;
        $count = 0;
        $score = 0;
        foreach ($photo->comments as $comment){
            $count++;
            $total += $comment->grade;
        }
        if ($total != 0 and $count != 0){
            $score = $total/$count;
        }

        return view('photos.show', compact('photo', 'score'));
    }


    /**
     * @param Photo $photo
     * @return RedirectResponse
     */
    public function destroy(Photo $photo): RedirectResponse
    {
        $this->authorize('delete', $photo);
        $photo->delete();
        return back()->with('success', 'photo successfully deleted');
    }
}

resources/views/photos/create.blade.php
@extends('layouts.app')

@section('content')
    @error('picture')
    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
    @enderror
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">@lang('messages.create')</div>
                <div class="card-body">
                    <form action="{{route('photos.store')}}" method="POST"
                          enctype="multipart/form-data">
                        @csrf
                        <div class="form-group row">
                            <label for="title" class="col-md-4 col-form-label text-md-right">@lang('messages.title')</label>
                            <div class="col-md-6">
                                <input class="form-control @error('title') is-invalid @enderror" type="text"
                                       id="title" name="title"
                                       value="{{ old('title') }}"/>
                                @error('title')
                                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                @enderror
                            </div>
                        </div>
                        <br>

                        <div class="form-group row">
                            <label for="picture"
                                   class="col-md-4 col-form-label text-md-right">@lang('messages.photo')</label>

                            <div class="col-md-6">
                                <input name="picture" type="file" class="custom-file-input @error('picture') is-invalid @enderror" id="picture" aria-describedby="picture">
                                @error('picture')
                                <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                                @enderror
                            </div>
                        </div>
                        <br>

                        <div class="form-group text-center">
                            <button type="submit" class="btn btn-outline-success">@lang('messages.create')</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

@endsection

resources/views/photos/index.blade.php
@extends('layouts.app')

@section('content')
    <br>
    <div class="row row-cols-1 row-cols-md-3 g-4">
        @foreach($photos as $photo)
        <div class="col">
            <div class="card">
                <img height="280" width="280" src="{{asset('/storage/' . $photo->picture)}}" class="card-img-top" alt="{{$photo->picture}}">
                <div class="card-body">
                    <h5 class="card-title">{{$photo->title}}</h5>
                    <p class="card-text">@lang('messages.by'): <a href="{{route('users.show', ['user' => $photo->user->id])}}">
                            {{$photo->user->name}}
                        </a></p>
                </div>
            </div>
        </div>
        @endforeach
    </div>
    <div class="row">
        <div class="col-md-auto">
            {{$photos->links('pagination::bootstrap-4')}}
        </div>
    </div>
@endsection

resources/views/photos/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col">
            <h2>{{$photo->title}}</h2>
            <img width="900" height="500" src="{{asset('/storage/' . $photo->picture)}}" alt="{{$photo->picture}}">
        </div>

        <div class="row" style="margin-top: 20px">
            <div class="col">
               <h5>@lang('messages.everage'): {{$score}}</h5>
            </div>
        </div>
        @if($photo->user_id != \Illuminate\Support\Facades\Auth::user()->getAuthIdentifier())
        @can('create', \App\Models\Comment::class)
                <h3 style="margin-top: 20px">@lang('messages.addComment')</h3>

            <form action="{{action([\App\Http\Controllers\CommentsController::class, 'store'])}}" method="post">
                @csrf

                    <label for="description"
                           class="col-md-4 col-form-label text-md-right">@lang('messages.description')</label>

                    <div class="col-md-6">
                                    <textarea class="form-control @error('description') is-invalid @enderror" id="description"
                                              rows="3" name="description">{{ old('description') }}</textarea>
                        @error('description')
                        <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                        @enderror
                    </div>

                <input type="hidden" name="photo_id" value="{{$photo->id}}">

                    <label for="institution_id" class="col-md-4 col-form-label text-md-right">@lang('messages.grade')</label>
                    <div class="col-md-6">
                        <select class="custom-select" name="grade">
                            <option value="1">1</option>
                            <option value="2">2</option>
                            <option value="3">3</option>
                            <option value="4">4</option>
                            <option value="5">5</option>
                        </select>
                    </div>
                <br>
                        <button type="submit" class="btn btn-primary">
                            @lang('messages.create')
                        </button>

            </form>
        @endcan
        @endif
        @foreach($photo->comments as $comment)
            <h5>@lang('messages.by'): {{$comment->user->name}}, {{$comment->grade}}</h5>
            <p>{{$comment->description}}</p>
        @endforeach
    </div>
@endsection